import java.io.IOException;
import javax.microedition.lcdui.*;
import javax.microedition.lcdui.game.*;

class LayerManagerTest extends GameCanvas implements Runnable { 
	  private LayerManager layer_manager;
	  private TiledLayer bg_img;   
	  public LayerManagerTest() throws IOException {		  
	    super(true);	    
	    layer_manager = new LayerManager();
	    layer_manager.setViewWindow(96, 0, 240, 291);
	    createBackground("/background_tiles.png");
	    Thread t = new Thread(this);
	    t.start();
	  }	  
	  private void createBackground(String background_img_file) throws IOException {
		Image background = Image.createImage(background_img_file);
	    int[] map = {
	      0, 0, 0, 0, 0, 8, 0, 0,
	      1, 2, 0, 0, 8, 0, 0, 0,
	      3, 3, 2, 0, 0, 0, 5, 0,
	      3, 3, 3, 2, 4, 1, 3, 2,	    
	      6, 6, 6, 6, 6, 6, 6, 6,
	      6, 6, 6, 6, 6, 6, 6, 6
	    };
	    bg_img = new TiledLayer(8, 6, background, 48, 48);
	    bg_img.setPosition(0, 0);
	    for(int i = 0; i < map.length; i++) {
	      int column = i % 8;
	      int row = (i - column) / 8;
	      bg_img.setCell(column, row, map[i]);
	    }
	    layer_manager.append(bg_img);
	  }	    
	  public void run() {
	    int w = getWidth();
	    int h = getHeight();
	    Graphics g = getGraphics();    
	    while (true) {
	    	g.setColor(0xffffff);
	        g.fillRect(0, 0, w, h);        
	        layer_manager.paint(g, 0, 0); 
	        flushGraphics();	      
	      try { 
	    	  Thread.sleep(80); }
	      catch(InterruptedException ie) {  }
	    }
	 }
}