import javax.microedition.lcdui.*;
import java.io.*;
class ThreadStarCanvas extends Canvas {
	private Image star_bg_img;
	private int stars_num, width, height;
	private int maxStars = 5;
	private ThreadStarClass[] stars;
	private ThreadStarClass thread_star_class;
	
	public ThreadStarCanvas() {
		width = getWidth();
		height = getHeight();
		try {
			star_bg_img = Image.createImage("/star_bg.png");
		} catch(IOException e) { 
			e.printStackTrace();
	    }
		stars = new ThreadStarClass[maxStars];
		stars[0] = new ThreadStarClass(this, 0, 0, width, height);
		stars_num = 1;
		Thread t = new Thread(stars[0]);
		t.start();
	}
	public void paint(Graphics g) {	
		g.setColor(0, 0, 0);
		g.drawRect(0, 0, getWidth(), getHeight());
		g.drawImage(star_bg_img, 0, 0, Graphics.TOP | Graphics.LEFT);	
		for(int i=0; i < stars_num; i++){
			stars[i].setStarPaint(g);
		}
		g.setColor(0xffffff);
		g.drawString(stars_num + "stars", 5, height-14, 0);
	}
	public void keyPressed(int keyCode) {      
		int action = getGameAction(keyCode);
		switch(action) {				 
			case LEFT:	
				if(stars_num > 0) {
					stars_num = stars_num - 1;
				}
				break;
			case RIGHT:
				if(stars_num < stars.length) {
					stars[stars_num] = new ThreadStarClass(this, 0, 0, width, height-12);
					new Thread(stars[stars_num]).start();	
					stars_num = stars_num + 1;
				}
				break;			 
			case UP:	    
				thread_star_class.faster();
				break;				
			case DOWN:
				thread_star_class.slower();
				break;
		}
		repaint(); 
    }
}