import javax.microedition.lcdui.*;
import javax.microedition.media.*;
import java.io.*;

public class ReadyGoCanvas extends Canvas implements Runnable {
	private byte gameState;
	private Thread thread;	
	private Player mPlayer;
	private boolean sound;
	private int width, height;
	/* Ready Go */
	private int stage, life, score, hidden, hint; 
	private int showCnt = 0;
	private int flow = 0;
	private Image readyGo_img;
	private Image BACK_IMG[] = null;
	private Image SMALLNUM_IMG[] = null;
	private Image BIGNUM_IMG[] = null;
	private Image ORIGINAL_IMG = null;
		
	public ReadyGoCanvas() {
		width = getWidth();
		height = getHeight();
		try {
			readyGo_img = Image.createImage("/readyGo.png");
		} catch (IOException e) { 
			System.out.println("̹    ϴ.");
		}
		commonGameInit();
		thread = new Thread(this);
		thread.start();     // run() ȣ
	}
	public void run() {
		while(true) {
			try {Thread.sleep(200);
			} catch(InterruptedException e) {
				System.out.println(e);
			}
			repaint();      // paint() ȣ
		}
	}
	public void paint(Graphics g) {
		if(flow <= 2) {
			draw_back(g);
			draw_readyGo(g);
		}
	}
	public void commonGameInit() { 
		hint = 3;
		life = 3;
		hidden =  4;		
		showCnt = 0;
		stage = 1;
		score = 0;
		BACK_IMG = createImg("back", 8);
		SMALLNUM_IMG = createImg("smallNum", 10);
		BIGNUM_IMG = createImg("bigNum", 5);				
		ORIGINAL_IMG = createImg("original", "stage");
		System.gc();
	}
	public void draw_readyGo(Graphics g) {
		showCnt++;
		if(showCnt < 5) {
			if(flow == 0) {
				soundPlay("ready"); 
				flow = 1;
			}
			g.setClip(width/2-(readyGo_img.getWidth()/2), height/2-16, readyGo_img.getWidth(), readyGo_img.getHeight()/2);
			g.drawImage(readyGo_img, width/2, height/2+16,Graphics.VCENTER|Graphics.HCENTER);
		}
		else if(showCnt < 10) {
			if(flow == 1) {	
				soundPlay("go"); 
				flow = 2; 
			}
			g.setClip(width/2-(readyGo_img.getWidth()/2), height/2-16, readyGo_img.getWidth(), readyGo_img.getHeight()/2);
			g.drawImage(readyGo_img, width/2, height/2-16,Graphics.VCENTER|Graphics.HCENTER);
		}
		else if(showCnt >= 10) {
			showCnt = 0;
			flow = 3; 
		}
		g.setClip(0,0,width, height);
	}
	public void draw_back(Graphics g) {
		// 輱()
		for(int i=0; i< width; i = BACK_IMG[4].getWidth()+i) {
			g.drawImage(BACK_IMG[4], i, 44, Graphics.TOP|Graphics.LEFT);
			g.drawImage(BACK_IMG[4], i, 244, Graphics.TOP|Graphics.LEFT);
		}
		// 輱 ()
		for(int i=0; i< width; i = BACK_IMG[4].getWidth()+i) {
			g.drawImage(BACK_IMG[4], i, 144, Graphics.TOP|Graphics.LEFT);
		}
		g.setColor(181, 181, 255);
		for(byte i=0; i<= width/10; i++) 		g.fillRect((10*i), 0, 5, 44);
		for(byte i=0; i<= width/10; i++)	    g.fillRect((10*i), 248, 5, 43);
		g.setColor(222, 222, 255);

		for(byte i=0; i<= width/10; i++) 		g.fillRect((10*i)+5, 0, 5, 44);
		for(byte i=0; i<= width/10; i++) 		g.fillRect((10*i)+5, 248, 5, 43);
		g.drawImage(BACK_IMG[0], 1, 0, Graphics.TOP|Graphics.LEFT);

		// hidden
		if(hidden >= 0)
			g.drawImage(BIGNUM_IMG[hidden], width/2-1,3, Graphics.TOP|Graphics.HCENTER);
			g.drawImage(SMALLNUM_IMG[stage/10], 28, 22, Graphics.TOP|Graphics.LEFT);	
			g.drawImage(SMALLNUM_IMG[stage%10], 44, 22, Graphics.TOP|Graphics.LEFT);
		
		// score
		int tempX = 164; 	
		String str = Integer.toString(score);	
		if(str.length() < 5) {
			for(byte i=0; i< 5 - str.length(); i++) {			
				g.drawImage(SMALLNUM_IMG[0], tempX, 22, Graphics.TOP|Graphics.LEFT);
				tempX += 14;
			}
		}
		for(byte i=0; i< str.length(); i++) {
			int a = Integer.parseInt(str.substring(i,i+1));
			g.drawImage(SMALLNUM_IMG[a], tempX, 22, Graphics.TOP|Graphics.LEFT);
			tempX += 14;
		}
		// time
		g.drawImage(BACK_IMG[1], 1,244, Graphics.TOP|Graphics.LEFT);		
		// life
		g.drawImage(BACK_IMG[2], 1, height-1, Graphics.BOTTOM|Graphics.LEFT);		
		g.drawImage(SMALLNUM_IMG[life], BACK_IMG[2].getWidth()+4, height-8 , Graphics.BOTTOM|Graphics.LEFT);		
		// hint
		g.drawImage(BACK_IMG[3], BACK_IMG[2].getWidth()+4+SMALLNUM_IMG[life].getWidth()+6, height-2, Graphics.BOTTOM|Graphics.LEFT);	
		g.drawImage(SMALLNUM_IMG[hint], BACK_IMG[2].getWidth()+4+SMALLNUM_IMG[life].getWidth()+6+BACK_IMG[3].getWidth()+8, height-8, Graphics.BOTTOM|Graphics.HCENTER);			
		// power	
		g.drawImage(BACK_IMG[6], width-(BACK_IMG[6].getWidth()/2), height-4, Graphics.BOTTOM|Graphics.LEFT);		
		// image
		g.drawImage(ORIGINAL_IMG,0, 48, Graphics.TOP|Graphics.LEFT);	
		g.drawImage(ORIGINAL_IMG,0, 148, Graphics.TOP|Graphics.LEFT);
	}
	public void soundPlay(String name) {
		soundStop();
		try	{
			InputStream in = getClass().getResourceAsStream("/"+name+".wav");
	  		mPlayer = Manager.createPlayer(in, "audio/x-wav");
	  		mPlayer.start();
		} catch(Exception e) {}
		sound = true;
	}
	final public void soundStop() {			
		if(mPlayer != null) {
			try {
				mPlayer.stop();
				mPlayer = null;
				sound = false;
			} catch(Exception e) { }
		}
	}
	public Image[] createImg(String add, int size) {
		Image img[] = null;
		try {
			img = new Image[size];
			for(byte i=0; i<size; i++)
				img[i] = Image.createImage("/images/"+add+"/0"+i+".png");
		} catch(Exception e) {
			System.out.println("Exception:"+e+"("+add+ ")");
		} catch(OutOfMemoryError omError) {
			System.out.println(add+ " out "+Runtime.getRuntime().freeMemory()); 
		}
		return img;
	}
	public Image createImg(String add, String name) {
		Image img = null;
		try {
			if(name.equals("stage")) 
				img = Image.createImage("/images/"+add+"/stage"+stage+".png");	
			else 
				img = Image.createImage("/images/"+add+"/"+name+".png");
		} catch(IOException e) {
			System.out.println(add+ " createImg ̹ .");
		} catch (OutOfMemoryError omError) {
			System.out.println(add+ " out "); 
		}
		return img;
	}
}